Require Export Arith.
Require Export ZArith.
Require Export QArith.
Require Import Reals.

Class Addition (number : Type) :={
  add : number -> number -> number
}.

Infix  "  + ":= add.

Instance Addition_Nat : Addition nat :={add:=plus}.

Instance Addition_Z : Addition Z :={add:=Zplus}.

Instance Addition_Q : Addition Q :={add:=Qplus}.

Typeclasses eauto := debug.

Eval compute in (let x:= (1)%nat in x+x).

Eval compute in (let x:= (1)%Z in x + x  ).

Eval compute in (let x:= (1)%Q in x + x  ).

Eval compute in (let x:= (1)%R in x + x  ).
(*  *)